#define SQUARE_MAX_WIDTH  800
#define SQUARE_MAX_HEIGHT 600
typedef struct {
    Tk_Window tkwin;		/* Window that embodies the extWin.  NULL
				 * means window has been deleted but
				 * widget record hasn't been cleaned up yet. */
    Tk_Window main;
    Window  win;
    Display *display;		/* X's token for the window's display. */
    Pixmap pixmap;
    Screen *screen;
    Tcl_Interp *interp;		/* Interpreter associated with widget. */
    int width;
    int height;

    int borderWidth;		/* Width of 3-D border around whole widget. */
    Tk_3DBorder bgBorder;	/* Used for drawing background. */
//    Tk_3DBorder fgBorder;	/* For drawing extWin. */
    int relief;			/* Indicates whether window as a whole is
				 * raised, sunken, or flat. */
    GC gc;			/* Graphics context for copying from
				 * off-screen pixmap onto screen. */
    int pipe_to_rem[2];
    int pipe_from_rem[2]; 
    int childPid;
    int updatePending;		/* Non-zero means a call to ExtWinDisplay
				 * has already been scheduled. */
} ExtWin;


static int		ExtWinConfigure _ANSI_ARGS_((Tcl_Interp *interp,
			    ExtWin *extWinPtr, int argc, char **argv,
			    int flags));
static void		ExtWinDestroy _ANSI_ARGS_((char *blockPtr));
static void		ExtWinDisplay _ANSI_ARGS_((ClientData clientData));
static void		ExtWinEventProc _ANSI_ARGS_((ClientData clientData,
			    XEvent *eventPtr));
static int		ExtWinWidgetCmd _ANSI_ARGS_((ClientData clientData,
			    Tcl_Interp *, int argc, char **argv));

